﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class RadGrid_Custom_FilterExpressions : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }


    protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = OrdersTable(); 
    }

    private DataTable OrdersTable()
    {
        DataTable dt = new DataTable();

        dt.Columns.Add(new DataColumn("OrderID", typeof(int)));
        dt.Columns.Add(new DataColumn("OrderDate", typeof(DateTime)));
        dt.Columns.Add(new DataColumn("Freight", typeof(decimal)));
        dt.Columns.Add(new DataColumn("ShipName", typeof(string)));
        dt.Columns.Add(new DataColumn("ShipCountry", typeof(string)));

        dt.PrimaryKey = new DataColumn[] { dt.Columns["OrderID"] };

        for (int i = 0; i < 70; i++)
        {
            int index = i + 1;

            DataRow row = dt.NewRow();

            row["OrderID"] = index;
            row["OrderDate"] = new DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day, 0, 0, 0).AddHours(index);
            row["Freight"] = index * 0.1 + index * 0.01;
            row["ShipName"] = "Name " + index;
            row["ShipCountry"] = "Country " + index;

            dt.Rows.Add(row);
        }

        return dt;
    }


    protected void RadButton1_Click(object sender, EventArgs e)
    {
        if (string.IsNullOrEmpty(RadTextBox1.Text) || string.IsNullOrEmpty(RadTextBox2.Text)) return;

        StringBuilder filterExpression = new StringBuilder();
        filterExpression.Append(string.Format("(it[\"ShipName\"].ToString().Contains(\"{0}\") OR it[\"ShipName\"].ToString().Contains(\"{1}\"))", RadTextBox1.Text, RadTextBox2.Text));
        RadGrid1.MasterTableView.FilterExpression = filterExpression.ToString();
        RadGrid1.Rebind();
    }

    protected void RadButton2_Click(object sender, EventArgs e)
    {
        if (string.IsNullOrEmpty(RadTextBox3.Text) || string.IsNullOrEmpty(RadTextBox4.Text)) return;

        StringBuilder filterExpression = new StringBuilder();
        filterExpression.Append(string.Format("(it[\"ShipName\"].ToString().Contains(\"{0}\") AND it[\"ShipName\"].ToString().Contains(\"{1}\"))", RadTextBox3.Text, RadTextBox4.Text));
        RadGrid1.MasterTableView.FilterExpression = filterExpression.ToString();
        RadGrid1.Rebind();
    }

    protected void RadGrid1_PreRender(object sender, EventArgs e)
    {
    }

    protected void RadButton3_Click(object sender, EventArgs e)
    {
        if (!string.IsNullOrEmpty(RadGrid1.MasterTableView.FilterExpression)) RadGrid1.MasterTableView.FilterExpression = string.Empty;
        RadGrid1.Rebind();
    }
}